import java.util.*;

public class shadowline_an {
    static class Point {
        int x;
        int y;
        boolean l;
        public Point(int x, int y, boolean l) {
            this.x = x;
            this.y = y;
            this.l = l;
        }

        public String toString() {
            return ("(" + x + "," + y + ")" + l);
        }
    }

    static class Event {
        int a;
        int b;
        long nl;
        long dl;
        public Event(int a, int b, long nl, long dl) {
            this.a = a;
            this.b = b;
            this.nl = nl;
            this.dl = dl;
        }
    }

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        int N = s.nextInt(), X = s.nextInt();
        Point[] points = new Point[2 * N];
        for (int i = 0; i < N; i++) {
            int x = s.nextInt(), yl = s.nextInt(), yh = s.nextInt();
            points[2 * i] = new Point(x, yl, true);
            points[2 * i + 1] = new Point(x, yh, false);
        }
        Point[] sweepline = new Point[2 * N];
        System.arraycopy(points, 0, sweepline, 0, 2 * N);
        Arrays.sort(points, (a, b) -> Integer.compare(a.x, b.x));
        Arrays.sort(sweepline, (a, b) -> Integer.compare(a.y, b.y));

        int[] overlap = new int[2 * N - 1];
        overlap[0] = 1;
        for (int i = 1; i < 2 * N - 1; i++) {
            if (sweepline[i].l) {
                overlap[i] = overlap[i - 1] + 1;
            } else {
                overlap[i] = overlap[i - 1] - 1;
            }
        }
        int[] hist = new int[N + 1];
        for (int i = 0; i < 2 * N - 1; i++) hist[overlap[i]]++;
        if (hist[0] == 0) {
            System.out.println(-1);
            return;
        }

        int[] idx = new int[2 * N];
        for (int i = 0; i < 2 * N; i++) {
            for (int j = 0; j < 2 * N; j++) {
                if (points[i] == sweepline[j]) {
                    idx[i] = j;
                    break;
                }
            }
        }

        ArrayList<Event> events = new ArrayList<>();
        for (int i = 0; i < 2 * N; i++) {
            if (points[i].y == 0) continue;
            for (int j = i + 1; j < 2 * N; j++) {
                if (points[i].x == points[j].x) continue;
                if (points[j].y == 0) continue;
                if (Math.signum(points[i].y) != Math.signum(points[j].y)) continue;
                long dl = (points[j].y - points[i].y);
                long nl = ((long) points[j].x) * (points[j].y - points[i].y) - ((long) points[j].y) * (points[j].x - points[i].x);
                if (dl < 0) {
                    dl *= -1;
                    nl *= -1;
                }
                double loc = nl / (double) dl;
                if (loc >= 0) continue;
                if (points[i].y < points[j].y) {
                    events.add(new Event(i, j, nl, dl));
                } else {
                    events.add(new Event(j, i, nl, dl));
                }
            }
        }

        Collections.sort(events, (a, b) -> Long.compare(a.nl * b.dl, b.nl * a.dl));
        double ans = 0;
        double prev = -1.0e30;
        for (Event e : events) {
            double loc = e.nl / (double) e.dl;
            if (hist[0] == 0) ans += loc - prev;
            if (sweepline[idx[e.a]].l && !sweepline[idx[e.b]].l) {
                hist[overlap[idx[e.a]]]--;
                overlap[idx[e.a]] -= 2;
                hist[overlap[idx[e.a]]]++;
            } else if (!sweepline[idx[e.a]].l && sweepline[idx[e.b]].l) {
                hist[overlap[idx[e.a]]]--;
                overlap[idx[e.a]] += 2;
                hist[overlap[idx[e.a]]]++;
            }
            Point temp = sweepline[idx[e.a]]; sweepline[idx[e.a]] = sweepline[idx[e.b]]; sweepline[idx[e.b]] = temp;
            idx[e.a]++;
            idx[e.b]--;
            prev = loc;
        }
        if (hist[0] == 0) ans -= prev;
        System.out.println(ans);
    }
}
